//----< depMatrix.cpp > ---------------------------------------------
//---- Author: Qiang Zheng ------------------------------------------
//
// About the definition and the explanation, please see the depMatrix.h
#include "iostream.h"
#include "depMatrix.h"

// constructors
depMatrix::depMatrix()
{
	size = 0;
	dependence = NULL;
	fileNames = NULL; 
}

// destructor
depMatrix::~depMatrix() 
{
	if ( dependence )
		delete dependence; 
	if ( fileNames )
		delete fileNames; 
}

//return the number of the files in the matrix
int depMatrix::getSize() 
{
	return size;
}

int depMatrix::indexOf( const char *fileName )
{
	for ( int i=0; i<size; i++ )
	{
		if ( strcmp( fileNames[i], fileName ) == 0 )
			return i;
	}
	// Increment matrix
	bool *newMatrix = new bool[(size+1)*(size+1)];
	for ( i=0; i<size; i++ )
		for ( int j=0; j<size; j++ )
			newMatrix[i*(size+1)+j] = dependence[i*size+j];
	for ( i=0; i<size+1; i++ )
	{
		newMatrix[i*(size+1)+size] = false;
		newMatrix[size*(size+1)+i] = false;
	}
	// Increment file list
	char **newList = new char *[size+1];
	for ( i=0; i<size; i++ )
		newList[i] = fileNames[i];
	newList[size] = newStr( fileName );

	delete fileNames;
	delete dependence;
	dependence = newMatrix;
	fileNames = newList;
	return size++;
}

void depMatrix::setDependence( int src, int dst )
{
	dependence[ src*size+dst ] = true;
}

void depMatrix::outputDependence()
{
	for ( int i=0; i<size; i++ )
	{
		cout<<"File "<<fileNames[i]<<" Depends on ";
		for ( int j=0; j<size; j++ )
		{
			if ( dependence[ i*size+j ] )
				cout<<fileNames[j]<<";";
		}
		cout<<"\n";
	}
}

